/*
Module : AAPARALLACTIC.H
Purpose: Implementation for the algorithms which calculate various celestial globe angles
Created: PJN / 29-12-2003

Copyright (c) 2003 - 2006 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/


#ifndef __AAPARALLACTIC_H__
#define __AAPARALLACTIC_H__


///////////////////////////// Classes /////////////////////////////////////////

class CAAParallactic
{
public:
//functions
  static double ParallacticAngle(double HourAngle, double Latitude, double delta);
  static double EclipticLongitudeOnHorizon(double LocalSiderealTime, double ObliquityOfEcliptic, double Latitude);
  static double AngleBetweenEclipticAndHorizon(double LocalSiderealTime, double ObliquityOfEcliptic, double Latitude);
  static double AngleBetweenNorthCelestialPoleAndNorthPoleOfEcliptic(double Lambda, double Beta, double ObliquityOfEcliptic);
};

#endif //__AAPARALLACTIC_H__
