/*
    STELE
    Copyright (C) 2006  Borca Bogdan <borca_bn@yahoo.com>
	www.bogdi.ro

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "main.h"

HDC			hDC = NULL;			// Private GDI Device Context
HGLRC		hRC = NULL;			// Permanent Rendering Context
HWND		hWnd = NULL;		// Holds Our Window Handle
HINSTANCE	hInstance;			// Holds The Instance Of The Application

RECT screen;

CCamera Camera;					// camera object used to move around the 3D scene.

unsigned short key[256];		// Input, keyboard
bool released_key[256];
unsigned int frames = 0, FPS = 0;

bool LBD, RBD, pln_Init;

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case 522:
			switch (wParam)
				// mouse scroll up
			{	case 7864320 : shuttle_speed += 0.007; break;
				// mouse scroll down
				case 4287102976 : shuttle_speed -= 0.007; break;
			}
			break;
		case WM_CREATE:					// Windows creation.
			hDC = GetDC(hwnd);          // This gets the device context for our window.
            SetupPixelFormat(hDC);      // Call the pixel format function.

			hRC = wglCreateContext(hDC);// Creates the rendering context.
            wglMakeCurrent(hDC, hRC);   // Makes the rendering context.
			pln_Init = false;
			break;

		case WM_KEYDOWN: key[wParam] = 1; break;
		case WM_KEYUP: key[wParam] = 0; break;

		case WM_CLOSE:			// Close message.

		case WM_DESTROY: 
			wglMakeCurrent(NULL,NULL);
			wglDeleteContext(hRC);
			// Deletes the rendering context.
			ReleaseDC(hWnd,hDC);
			UnregisterClass("Stele Build 0514", hInstance);
			PostQuitMessage(0);	
			// Says close the program.
            break;
		case WM_MOUSEMOVE:
			{
			if (bool_options[11] || gui_is_active) goto SKIPP_MM;
			if ((LOWORD(lParam) == wwidth/2) && (HIWORD(lParam) == wheight/2)) goto SKIPP_MM;
			Camera.RotateX((bool_options[2]?(-1):(1))*((wheight/2 - HIWORD(lParam))/(bool_options[2]?4:2))); 
			Camera.RotateY((bool_options[2]?(-1):(1))*((wwidth/2 - LOWORD(lParam))/(bool_options[2]?4:2))); 
			SetCursorPos(wwidth/2, wheight/2);
			break;
			}
SKIPP_MM: xmouse = LOWORD(lParam);
		ymouse = HIWORD(lParam);
			break;
        
		case WM_SIZE:						// re-size message.
			{	
			int height  = HIWORD(lParam);	// This gets the height of the window.
            int width = LOWORD(lParam);     // This gets the width of the window.
            glViewport(0, 0, width, height);// resets the viewport to new dimensions.
			set_view();
			}
			break;
		// mouse buttons control roll
		case WM_LBUTTONDOWN: LBD = 1; break;
		case WM_RBUTTONDOWN: RBD = 1; break;
        case WM_LBUTTONUP: LBD = 0; break;
        case WM_RBUTTONUP: RBD = 0; break;

		case WM_TIMER:
			switch (wParam)     
			{
				case 1 : FPS = frames; frames = 0; break;
			}
			break;
		default: 
		// Always have a default just in case.
		return (DefWindowProc(hwnd, message, wParam, lParam));   
	}

   // What this does is pass all of the unhandled messages to DefWindowProc.
	return (0);
}

#include <windows.h>


void set_view()
{
	glMatrixMode(GL_PROJECTION);    // Sets the projection matrix.
	glLoadIdentity();               // Reset the modelview matrix.
	if (wheight==0) wheight = 1;	// we don't want it to be possible for a
									// height of 0.  If it is 0 me make it 1.
	if (!bool_options[2]) gluPerspective(65.0L, (double)wwidth/(double)wheight, 0.001L, 75000.0L);
	else glOrtho(-zoom*wwidth/wheight, zoom*wwidth/wheight, 
		-zoom, zoom,
		-75000.0L, 75000.0L);
	glMatrixMode(GL_MODELVIEW);     // Sets the projection matrix.
	glLoadIdentity();               // Reset the modelview matrix.
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	MSG msg;					// A message variable.
	WNDCLASSEX windowClass;		// My Window class.

	bool isFinished;			// This will be used to check if the program is done or not.
	
//	DEVMODE dmScreenSettings;

//	memset(&dmScreenSettings, 0, sizeof(DEVMODE));
//	dmScreenSettings.dmSize	= sizeof(DEVMODE);
//	dmScreenSettings.dmPelsWidth = 800;
//	dmScreenSettings.dmPelsHeight = 600;
//	dmScreenSettings.dmFields	= DM_PELSWIDTH | DM_PELSHEIGHT;
//	ChangeDisplaySettings(&dmScreenSettings, CDS_FULLSCREEN);	
	
	GetWindowRect(GetDesktopWindow(), &screen);
	// This is the Window class.
	windowClass.cbSize = sizeof(WNDCLASSEX);			// size of the WNDCLASSEX structure.
	windowClass.style = CS_HREDRAW | CS_VREDRAW;		// style of the window.
	windowClass.lpfnWndProc = WndProc;					// Address to the windows procedure.
	windowClass.cbClsExtra = 0;							// Extra class information.
	windowClass.cbWndExtra = 0;							// Extra window information.
	windowClass.hInstance = hInstance;					// Handle of application Instance.
	// Handle of application Icon.
	windowClass.hIcon = NULL;
	windowClass.hCursor = LoadCursor(NULL, IDC_ARROW);	// mouse cursor
	windowClass.hbrBackground = NULL;					// background color.
	windowClass.lpszMenuName = NULL;					// name of the main menu.
	windowClass.lpszClassName = "Stele";				// window class name.
	windowClass.hIconSm = (HICON)LoadImage(NULL, "stele.ico", IMAGE_ICON, 32, 32, LR_LOADFROMFILE);
	// You must register you class with Windows.
	if(!RegisterClassEx(&windowClass)) return 0;
	wwidth = screen.right;
	wheight = screen.bottom;
	// Create the window.
	hWnd = CreateWindowEx(WS_EX_APPWINDOW,		// The extended window style.
                        "Stele",				// window Class name.
                        "Stele [0526]",			// window name.
						WS_MAXIMIZE | WS_CLIPCHILDREN |
						WS_CLIPSIBLINGS |  WS_POPUPWINDOW | WS_VISIBLE,
	                    0, 0,					// window x, y coordinate.
                        wwidth, wheight,		// window width and height.
                        NULL,		// handle to parent window.
                        NULL,		// menu.
                        hInstance,	// handle to app instance.
                        NULL);		// pointer to window creation data.
   
	// If there was an error with creating the window, then close the program.
	if (!hWnd) 
	{	ErrorExit("CreateWindowEx");
		return 0;
	}

	ShowWindow(hWnd, SW_SHOW); // This shows the window.
	UpdateWindow(hWnd);        // This forces a paint message.
	wglMakeCurrent(hDC,hRC);
	isFinished = false;        // False = running, True = not running.

	// If initialize fail (return false), then we don't want the program to run.
	if(!init()) isFinished = true;
	// Imi setez un TIMER used to identify one second to calculate FPS
	SetTimer(hWnd, TIMER, 1000, (TIMERPROC) NULL);

	// This is the messsage loop.
	while(!isFinished)								// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message == WM_QUIT)				// Have We Received A Quit Message?
			{
				isFinished = TRUE;					// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
			render();								// Render a frame
			// following http://www.bogdi.ro/projects/stele_specification.htmhttp://www.bogdi.ro/projects/stele_specification.htm

			// I -> show/hide the planet's distance to the Sun
			if (key['I']) { bool_options[0] = !bool_options[0]; key['I']=false; }
			// G -> show/hide grid
			if (key['G']) { bool_options[1] = !bool_options[1]; key['G']=false; }
			// activate Ortographic or Perspective view
			if (key['V']) { 	
				bool_options[2] = !bool_options[2]; 
				set_view();
				key['V']=false; 
			}
			// Y -> connects the camera to the nearest planet (!not satellite)
			if (key['2']==1) 
			{ 
				Camera.distance_difference = F3dVector(PO[near_planet - 1][18] - Camera.Position.x, PO[near_planet - 1][20] - Camera.Position.y, PO[near_planet - 1][19] - Camera.Position.z);
				key['2'] = 0;
				bool_options[3] = !bool_options[3];
			}
			if (bool_options[3]) 
			{ 
				Camera.Position = F3dVector(PO[near_planet - 1][18] - Camera.distance_difference.x, PO[near_planet - 1][20] - Camera.distance_difference.y, PO[near_planet - 1][19] - Camera.distance_difference.z);
			}	
			// Space -> show/hide the planet's description
			if (key[VK_SPACE]) { bool_options[4] = !bool_options[4]; key[VK_SPACE]=false; }
			// J -> jumps to the next planet
			if (!key['J']) released_key['J'] = 0;
			if (key['J'] && released_key['J'] == 0) 
			{
				//[13] is planet's diameter
				//[17] x [18] y [19] z
				if (near_planet==planets + 1) near_planet = 0;
				Camera.Position = F3dVector (PO[near_planet][18] - (PO[near_planet][0] / 100000) - 0.1 , PO[near_planet][19] , PO[near_planet][20]); 
				Camera.MoveForward(0);
				released_key['J'] = 1;
				camera_changed = true;
			}
			//
			if (key['N']==1) { shuttle_speed = console = 10; }
			if (key['M']==1) { shuttle_speed = console = 0.022; }

			if (key['A']==1) { if (!bool_options[3]) { camera_changed = true; Camera.StrafeRight( -shuttle_speed ); }}
			if (key['D']==1) { if (!bool_options[3]) { camera_changed = true; Camera.StrafeRight( shuttle_speed ); }}

			if (key['W']==1) { 
				if (!bool_options[3]) 
				{
					if (bool_options[2])
					{
						zoom = zoom - shuttle_speed*4;
						set_view();
					} else Camera.MoveForward( -shuttle_speed );
					camera_changed = true; 
				}
			}

			if (key['S']==1) { 
				if (!bool_options[3]) 
				{ 
					if (bool_options[2])
					{
						zoom = zoom + shuttle_speed*4;
						set_view();
					} else Camera.MoveForward( shuttle_speed );
					camera_changed = true; 
				}
			}

			if (key['Q']==1) { Camera.RotateZ( 0.5 ); }
			if (key['E']==1) { Camera.RotateZ( -0.5 ); }
			
			if (LBD && !gui_is_active) { Camera.RotateZ( 1.0 ); }
			if (RBD && !gui_is_active) { Camera.RotateZ( -1.0 ); }
			if (LBD && gui_is_active) { 
				LBD = 0;
				if (active_GUI_option > -1)
				{
					bool_options[active_GUI_option] = !bool_options[active_GUI_option];
					if (active_GUI_option==2) set_view();
					if (bool_options[3]) Camera.distance_difference = F3dVector(PO[near_planet - 1][18] - Camera.Position.x, PO[near_planet - 1][20] - Camera.Position.y, PO[near_planet - 1][19] - Camera.Position.z);
				}else {
					SetCursorPos(wwidth/2, wheight/2);
					gui_is_active = false;
					ShowCursor(false);
					if (mouse_on_exit) 
					{ if (mouse_over_quad_area(xmouse, ymouse, 5, 55, wheight/2-104 + 2*14, wheight/2-104 + 2*14 + 14))
						PostQuitMessage(0);
					}
				}
			}

			if (!key[VK_ESCAPE]) released_key[VK_ESCAPE] = 0;
			if (key[VK_ESCAPE] && released_key[VK_ESCAPE] == 0) 
			{ 
				gui_is_active = !gui_is_active;
				//static_tv = gui_is_active;
				//if (static_tv) ii = 0;
				ShowCursor(gui_is_active?1:0);
				released_key[VK_ESCAPE] = 1;
				if (!gui_is_active) SetCursorPos(wwidth/2, wheight/2);
			}
			// close the app if the user presses 5.
			if (key['5']) {PostQuitMessage(0); }

		}
	}
	void Shutdown();
	return (int)msg.wParam;      // End the application.
}

void SetupPixelFormat(HDC hDC)
{
   int nPixelFormat;

   static PIXELFORMATDESCRIPTOR pfd = {
         sizeof(PIXELFORMATDESCRIPTOR),		// size of structure.
         1,									// always 1.
         PFD_DRAW_TO_WINDOW |				// support window
         PFD_SUPPORT_OPENGL |				// support OpenGl
         PFD_DOUBLEBUFFER,					// support double buffering
         PFD_TYPE_RGBA,						// support RGBA
         16,								// bit color mode
         0, 0, 0, 0, 0, 0,					// ignore color bits
         0,									// no alpha buffer
         0,									// ignore shift bit
         0,									// no accumulation buffer
         0, 0, 0, 0,						// ignore accumulation bits.
         16,								// number of depth buffer bits.
         0,									// number of stencil buffer bits.
         0,									// 0 means no auxiliary buffer
         PFD_MAIN_PLANE,					// The main drawing plane
         0,									// this is reserved
         0, 0, 0 };							// layer masks ignored.

   // this chooses the best pixel format and returns index.
   nPixelFormat = ChoosePixelFormat(hDC, &pfd);

   // This set pixel format to device context.
   SetPixelFormat(hDC, nPixelFormat, &pfd);
}

bool init()
{
	// clear the screen to the specified color.
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);
	// set camera
	Camera.Position.x = -100;
	Camera.RotateX(0);
	// init the grid
	g_init(1400, 0, 0, -300, 14);	
	g_initlist();
	// create Fonts
	listBase[0] = fnt_Init("Arial", 12, hDC);
	listBase[1] = fnt_Init("Courier New", 14, hDC);
	// Set scene
	scn_init();
	load_splash_screen(JPEG_Texture("maps/splash13.jpg"));
	console = shuttle_speed;
	return init_file();
}

bool loaded()
{
	static int seq = 0;

	if (seq == 7) return true;

	display_splash_screen();	// splash screen is a term used to describe an image that appears while a computer program is loading. 
								// the splash screens of operating systems and some applications that expect to be run full-screen usually cover the entire screen.
	switch (seq)
	{
		case 0:	if (load_config_file()) seq++; break;
		case 1: load_pxyz(); seq++; break;
		case 2: load_rings(); seq++; break;
		case 3: load_GUI_textures(); seq++; break;
		case 4: load_space(); seq++; break;
		case 6:	unload_splash_screen(); seq++; break;
		case 5:	s_init(); seq++; break;					// sun init
	}
	return (seq == 7);
}

void render()
{
	// Clears the screen.
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);   
	// Reset modelview matrix for new frame.
 	glLoadIdentity(); 

	if (!loaded()) goto LOADING;
	// Camera set based on mouse move and keyboard
	Camera.Render();

	// Grid display
	if (camera_changed) g_update(Camera.Position.x, Camera.Position.y);
	g_display();
	// Display the entire system
	glCallList(pixel_list);	
	draw_system(Camera.Position);
	// Draw the sun
	s_draw();
	// Display 2D Info
	w_2DInfo(listBase[0], shuttle_speed, FPS);
	// GUI display
	left_panel();	
	right_panel();					
	// Aply light
	set_light();

LOADING:;
	glFlush();
	SwapBuffers(hDC);
	frames++;
}

void Shutdown()
{
	gluDeleteQuadric(qsphere);
}