/*
    STELE
    Copyright (C) 2006  
	Borca Bogdan <borca_bn@yahoo.com>
	www.bogdi.ro

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "afisare.h"

void w_init()
{
	show_infos = true;
	for(unsigned short i=0; i<3; i++) w_cp_init("", 0, 0, 0, i);
}

void w_cp_init(char pname[], long color, double distance, unsigned short ID, unsigned short i)
{
	cp[i].color = color;
	strcpy(cp[i].pname, pname);
	cp[i].distance = distance;
	cp[i].ID = ID;
}

void w_2DInfo(unsigned int listBase,
					  float shuttle_speed,unsigned int FPS)
{
	//afs_closest_planets
	if (!show_infos) return;
	set_2D_for_draw(0,1);//);ecran_latime, ecran_inaltime);
	fnt_PrintText_lt_off_color(
		true, listBase, true, false, wwidth - 140, 80, true, 255255255 /* the color */, "Closest planets");
	fnt_PrintText_lt_off_color(
			true, listBase, false, false, wwidth - 140, 95, true, cp[0].color /* the color */, "%s : %.2f", cp[0].pname, cp[0].distance / 10);
	fnt_PrintText_lt_off_color(
			true, listBase, false, false, wwidth - 140, 110, true, cp[1].color /* the color */, "%s : %.2f", cp[1].pname, cp[1].distance / 10);
	fnt_PrintText_lt_off_color(
			true, listBase, false, false, wwidth - 140, 125, true, cp[2].color /* the color */, "%s : %.2f", cp[2].pname, cp[2].distance / 10);
	//afs_shuttle_speed_FPS
	fnt_PrintText_lt_off_color(
		true, listBase, false, false, 50, wheight - 30, true, 255255255 /* the color */, "Shuttle speed: %.4f^Sun distance: %.4f mil km.", shuttle_speed, camera_sun_distance / 10);
	fnt_PrintText_lt_off_color(
		true, listBase, false, false, 50, 20, false, 0 /* the color */, "FPS:%d^%d/%d/%d %d:%d:%d", FPS, 
			systemtime.wDay, 
			systemtime.wMonth, 
			systemtime.wYear,
			systemtime.wHour,
			systemtime.wMinute,
			systemtime.wSecond);
	unset_2D_for_draw();
}

void w_get_closest_planets( 
	char pname[], long color, int ID, unsigned short planete,
	double distance_from_camera_to_planet)
{
	if (!camera_changed) return; 

	unsigned short k = 0, i = 0, j = 0;

	while ((distance_from_camera_to_planet>=cp[i].distance) && (cp[i].distance != 0) && (i < 3)) { i++; } 

	while ((0!=strcmp(cp[k].pname, pname))&& (k < 3)) { k++; }

	for (j = k; j > i; j-- )
	{ 
		w_cp_init(cp[j-1].pname, cp[j-1].color, cp[j-1].distance, ID, j); 
	}
	
	w_cp_init(pname, color, distance_from_camera_to_planet, ID, j);
}

void w_planet_name()
{
	// write the planet's name and/or it's distance to the Sun
	if (bool_options[0]) 
	{ fnt_PrintText_lt_off_color(true, listBase[0], false, false, PO[iP][0] / 100000 + 0.5, 1.0f,  true, PO[iP][16] /* the color */, "%s %.2f" /* %.5f %.5f %.5f" */, planet[iP].name, PO[iP][21]/*, PO[iP][17] , PO[iP][19], PO[iP][18]*/); }
	else 
	{ fnt_PrintText_lt_off_color(true, listBase[0], false, false, PO[iP][0] / 100000 + 0.5, 1.0f,  true, PO[iP][16] /* the color */, "%s", planet[iP].name); }
}