/*
    STELE
    Copyright (C) 2006  
	Borca Bogdan <borca_bn@yahoo.com>
	www.bogdi.ro

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "font.h"

unsigned int fnt_Init(char *fontName, int Size, HDC hDC)
{
	HFONT hFont;
	// Windows font.

	unsigned int base;

	base = glGenLists(96);
	// create space for 96 characters.
	hFont = CreateFont(Size, 0, 0, 0, 400, FALSE, FALSE, FALSE,
		ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
		ANTIALIASED_QUALITY, FF_DONTCARE | DEFAULT_PITCH, fontName);
	// create font (see Windows API)
	if(!hFont) return 0;

	SelectObject(hDC, hFont);
	wglUseFontBitmaps(hDC, 32, 96, base);

	return base;
}

void fnt_PrintText_lt_off_color(bool draw, 
		GLuint base,
		bool lt_off, bool lt_on,
		GLfloat x, GLfloat y, 
		bool color_on, long color, 
		const char *fmt, ...)
{
	if (!draw) return;
	if((base == 0 || fmt == NULL)) return;
	if (lt_off) set_light_texture_off(true);
	if (color_on) set_color(color, 1, 0);
    
	va_list args; char buf[1400]; unsigned short i = 0, j = 0;

	va_start(args, fmt);
	vsprintf (buf, fmt, args);
	va_end(args);
	glPushAttrib(GL_LIST_BIT);

NEW_LINE:
	glRasterPos2f(x, y);

	glListBase(base - 32);

	char *newline = strchr(buf + i, '^');
	if (newline==NULL) i = strlen(buf); else i = strlen(buf) - strlen(newline);
//	while ((buf[i] != '^') && (i < strlen(buf))) { i++; }
	glCallLists(i - j, GL_UNSIGNED_BYTE, &buf[j]);
	i++; j = i;
	if (i < strlen(buf)) { y = y + 15; ynewline = y; goto NEW_LINE; }

	glPopAttrib();
	if (lt_on) set_light_texture_off(false);
}