/*
    STELE
    Copyright (C) 2006  
	Borca Bogdan <borca_bn@yahoo.com>
	www.bogdi.ro


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include"grid.h"

GLuint grid_list;
GLfloat x, y, z, wide, line, lines;	

GLvoid g_init(long wide_, long x_, long y_, long z_, long lines_)
{
	x = x_	; 
	y = y_; 
	z = z_;
	wide = wide_;
	line = -(wide / 2);
	lines = lines_;
}

GLvoid g_initlist()
{
	grid_list = glGenLists(1);
	glNewList(grid_list, GL_COMPILE);

	glColor3f(0.6f, 0.6f, 0.6f);
	glBegin(GL_LINES);	
	for(int grid = 0; grid <= wide; grid += wide / lines)
	{ 
		dr_line(line + grid, line, 0, line + grid, -line, 0);	
	}
	glEnd();
	glBegin(GL_LINES);
	glColor3f(0.5f, 0.5f, 0.7f);	
	for(int grid = 0; grid <= wide; grid += wide / lines)
	{ 
		dr_line(line, line + grid, 0, -line, line + grid, 0);	
	}
	glEnd();
	glEndList();
}

GLvoid g_update(long x_, long y_)
{
	if (!bool_options[1]) return;
	while (y_ >= wide / 2 + y) {y += wide;}
	while (x_ >= wide / 2 + x) {x += wide;}
	while (y_ <= -wide / 2 + y) {y -= wide;}
	while (x_ <= -wide / 2 + x) {x -= wide;}
}

GLvoid g_writelocation 
	(long x, long y, long z,
     double location)
{
	glTranslatef(x + 10, y, z);
	fnt_PrintText_lt_off_color(true, listBase[1], false, false, 0.0f, 0.0f, false, 0, "%.0f", location / 10);
	glTranslatef(-x - 10, -y, -z);
}

GLvoid g_display()
{
	if (!bool_options[1]) return;

	glPushMatrix();

	glDisable(GL_TEXTURE_2D);
	glTranslatef(x, y, z);

	glCallList(grid_list);
	glColor3f(0.5, 0.5, 0.5);

	glTranslatef(700, -700, 0);
	fnt_PrintText_lt_off_color(true, listBase[1], false, false, 0.0f, 0.0f, false, 0, "mil km.");
	glTranslatef(-700, 700, 0);

	for(int grid = wide / lines; grid <= wide; grid += wide / lines)
	{
		g_writelocation(
			-line - grid/* x */,  -line/* y */,  0/* z */, 
			(double)(line + grid - x) /* x location */);
		g_writelocation(
			-line /* x */, line + grid /* y */, 0 /* z */, 
			(double)(-line - grid - y) /* z location */);
	}
	glPopMatrix();
}