/*
    STELE
    Copyright (C) 2006  
	Borca Bogdan <borca_bn@yahoo.com>
	www.bogdi.ro

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include"soare.h"

//#define MAX_PARTICLES 40		// Number Of Particles To Create
//#define slowdown 30				// Slow Down Particles
#define SUN 180

GLfloat sun_rot = 0;				// Base X/Y Speed

/*
typedef struct					// Create A Structure For Particle
{
	float	life;				// Particle Life
	float	fade;				// Fade Speed
	float	x;					// X Position
	float	y;					// Y Position
	float	z;					// Z Position
	float	xi;					// X Direction
	float	yi;					// Y Direction
	float	zi;					// Z Direction
}particles;
*/

//particles particle[40];			// Particle Array (Room For Particle Info)	

GLvoid s_draw()
{
	// save the current modelview matrix
	glPushMatrix();	
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_DST_ALPHA);
	// call list to display sun sphere	
	glColor3f(1.0f, 1.0f, 0.5f);
	s_drawfire();	
	glCallList(list[1][9]);		
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_DEPTH_TEST);
	glPopMatrix();
}

GLvoid s_init()
{
	list[0][5] = JPEG_Texture("maps/Flares/Flare4.jpg");
	list[0][6] = JPEG_Texture("maps/smoke.jpg");
	list[1][9] = generate_sphere_list(13.91, false, false, false, JPEG_Texture("maps/sunmap.jpg"));
/*
	for (short loop = 0; loop < MAX_PARTICLES ; loop++)		// Initials All The Textures
	{
		particle[loop].fade = 0.1;
	}
*/

}

GLvoid s_drawfire()
{
	l3dBillboardCheatSphericalBegin();
	sun_rot = sun_rot + 0.07f;
	glRotatef(sun_rot/2, 0, 0, 1);
	glColor3f(1.0f, 1.0f, 0.0f);
	dr_quad(list[0][5], GL_QUADS, -SUN, SUN, SUN, -SUN, 0);
	glRotatef(-sun_rot, 0, 0, 1);	
	glColor3f(1.0f, 1.0f, 1.0f);
	gluDisk(qsphere, 13.91,  120.0f, 64, 24);

/*
	for (short loop=0; loop < MAX_PARTICLES; loop++)		// Loop Through All The Particles
	{
		float x = particle[loop].x;					// Grab Our Particle X Position
		float y = particle[loop].y;					// Grab Our Particle Y Position

		// Draw The Particle Using Our RGB Values, Fade The Particle Based On It's Life
		glBindTexture(GL_TEXTURE_2D, list[0][6]);
		glColor4f(0.2,0.2,0.8,particle[loop].life);
		glBegin(GL_TRIANGLE_STRIP);					// Build Quad From A Triangle Strip
		    glTexCoord2d(1,1); glVertex3f(x+18,y+18,0); 
			// Top Right
			glTexCoord2d(0,1); glVertex3f(x-18,y+18,0); 
			// Top Left
			glTexCoord2d(1,0); glVertex3f(x+14,y-18,0); 
			// Bottom Right
			glTexCoord2d(0,0); glVertex3f(x-18,y-18,0); 
			// Bottom Left
		glEnd();									// Done Building Triangle Strip
			
			particle[loop].x += particle[loop].xi/(slowdown);// Move On The X Axis By X Speed
			particle[loop].y += particle[loop].yi/(slowdown);// Move On The Y Axis By Y Speed

			particle[loop].life = particle[loop].life - particle[loop].fade;	// Reduce Particles Life By 'Fade'
			
			if (particle[loop].life < 0.0f)				// If Particle Is Burned Out
			{
				particle[loop].life = 1.8;				// Give It New Life
				particle[loop].fade = float(rand()%100)/1500.0L + 0.03L;		
				// random fade value
				particle[loop].x = particle[loop].y = 0.0f;					// Center On X Axis
				particle[loop].xi = float((rand()%50)-25.0f)/2;	
				// xspeed+ X Axis Speed And Direction
				particle[loop].yi=float((rand()%50)-25.0f)/2;	
				// yspeed+ Y Axis Speed And Direction
			}
   } 
*/
}

GLvoid l3dBillboardCheatSphericalBegin() 
{
	float modelview[16];

	// get the current modelview matrix
	glGetFloatv(GL_MODELVIEW_MATRIX , modelview);

	// undo all rotations
	// beware all scaling is lost as well 
	for(int i=0; i<3; i++ ) 
		for(int j=0; j<3; j++ ) 
		{ modelview[i*4+j] = (i==j); }

	// set the modelview with no rotations
	glLoadMatrixf(modelview);
}