// Bogdan 2006 : borca_bn@yahoo.com

#ifndef _VARIABILE_H_
#define _VARIABILE_H_

#include<gl\glu.h>
#include<windows.h>
#include<time.h>
#include<sys\timeb.h>
#include"AA+\AADate.h"

#define AU 149597870.691L		// One AU means the mean distance from the Sun to the Earth
#define TIMER 1
#define PI 3.141592653589793238462643383279502884197169399375105
#define Radian 0.017453292519943295769236907684883
#define SECS_A_DAY (86400)
#define Vector4(V4, X, Y, Z, B) { V4[0] = X; V4[1] = Y; V4[2] = Z; V4[3] = B; }
#define SF3dVectorInit(V3, X, Y, Z) { V3.x = X; V3.y = Y; V3.z = Z; }

typedef struct
{
	double x, y, z;
}Vector3;

struct SF3dVector				// Float 3d-vect, normally used
{
	double x, y, z;
};

struct Fade
{
	SF3dVector fstart, fend, toxyz;
	bool fade;
};
extern Fade _fade;

typedef	struct 					// declare a struct for one planet
{								 
	short moonIDs[8];			// this will hold IDs for moons
	char name[10];				// this will hold planet's name
	char description[1400];		// it's description
	GLfloat transparency;		// and it's atmosphere transparency coeficient
}PLANET_OBJECT;
extern PLANET_OBJECT planet[9];

typedef struct					// declare a struct for one satellite
{
	char name[10];				// this will hold satellite's name				// satellite name
	char description[1400];		// and it's description
}SATELLITE_OBJECT;
extern SATELLITE_OBJECT moon[15];

typedef struct
{
	double distance;			// distance to the closest planet
	char pname[10];				// from the camera so this is a
	long color;					// camera-planet distance
	int ID;	
}CP;
extern CP cp[4];

extern GLfloat mat_ambient[4], mat_specular[4], mat_diffuse[4], mat_emission[4],
	light_position[4];

extern short planets, iP, near_planet, active_GUI_option, active_OK;
extern int wwidth, wheight, ynewline;
extern GLuint list[10][20], listBase[3], pixel_list;
extern char options[46][45];

extern double 
	PO[9][24],					// this will hold data for 9 planets with 25 double attributes
	MO[15][4],					// this will hold data for 25 satellites with 5 double attributes
	mili,
	Julian,
	moon_rot,
	shuttle_speed,
	xmouse,
	ymouse,
	ii,
	console,
	camera_sun_distance,
	camera_planet_distance,
	zoom,
	zs,
	_21;

extern bool
	bool_options[14],
	gui_is_active,
	show_infos,
	show_GUI,
	camera_changed,
	initsf3,
	mouse_on_exit,
	static_tv;

extern CAADate date;

extern SYSTEMTIME systemtime;
extern time_t time_date;

extern HWND hWnd;			// holds Our Window Handle
extern HDC hDC;				// device Context
extern HGLRC hRC;			// permanent Rendering Context
extern HINSTANCE hInstance;	// holds The Instance Of The Application

extern GLUquadric *qsphere;

#endif _VARIABILE_H_

/*	
the 25 double attributes for one planet are:
[0]		4878 				diameter of the planet
		/mercurymap.jpg 	texture
[1]		4.092353			daily motion
[2]		0.38709893			a_mean_distance_AU
[3]		0.00000066			a_mean_distance_AU_Cy
[4]		0.20563069			e_eccentricity_AU
[5]		0.00002527			e_eccentricity_AU_Cy
[6]		7.00487				i_inclination_deg_AU inclination (deg)
[7]		-23.51				i_inclination_deg_AU_Cy
[8]		48.333899			o_longit_of_asc_node_AU longitude of ascending node (deg)
[9]		0					o_longit_of_asc_node_AU_Cy
[10]	77.45645			w_longit_of_perih_deg_AU the position in the orbit where the planet is closest to the Sun
[11]	573.57				w_longit_of_perih_deg_AU_Cy
[12]	314.423688			L_mean_longit_deg_AU mean longitude (deg), the position of the planet in the orbit
[13]	0					number_of_moons
[14]	0.01				axial_tilt	
[15]	0					years, in Earth years, year
[16]	64128192			planet's color
above attributes are taken from Stele.cfg

[18] x_coord				planet coordinates X Y Z
[19] y_coord
[20] z_coord
[21] distance				distance to the sun
[22] rotation_degrees		rotation of the planet in degrees, night/day
above attributes are calculated based attributes from 1 to 15

the 4 double attributes for one satellite are:
[0]		3476				satellite diameter
[1]		6.410000        	body tilt
		/moon.jpg			texture
[2]		384400				orbit
[3]		27.32				one cycle around parent in parent's days


*/